require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe DepartmentShiftsController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # DepartmentShift. As you add validations to DepartmentShift, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) {
    skip("Add a hash of attributes valid for your model")
  }

  let(:invalid_attributes) {
    skip("Add a hash of attributes invalid for your model")
  }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # DepartmentShiftsController. Be sure to keep this updated too.
  let(:valid_session) { {} }

  describe "GET #index" do
    it "assigns all department_shifts as @department_shifts" do
      department_shift = DepartmentShift.create! valid_attributes
      get :index, {}, valid_session
      expect(assigns(:department_shifts)).to eq([department_shift])
    end
  end

  describe "GET #show" do
    it "assigns the requested department_shift as @department_shift" do
      department_shift = DepartmentShift.create! valid_attributes
      get :show, {:id => department_shift.to_param}, valid_session
      expect(assigns(:department_shift)).to eq(department_shift)
    end
  end

  describe "GET #new" do
    it "assigns a new department_shift as @department_shift" do
      get :new, {}, valid_session
      expect(assigns(:department_shift)).to be_a_new(DepartmentShift)
    end
  end

  describe "GET #edit" do
    it "assigns the requested department_shift as @department_shift" do
      department_shift = DepartmentShift.create! valid_attributes
      get :edit, {:id => department_shift.to_param}, valid_session
      expect(assigns(:department_shift)).to eq(department_shift)
    end
  end

  describe "POST #create" do
    context "with valid params" do
      it "creates a new DepartmentShift" do
        expect {
          post :create, {:department_shift => valid_attributes}, valid_session
        }.to change(DepartmentShift, :count).by(1)
      end

      it "assigns a newly created department_shift as @department_shift" do
        post :create, {:department_shift => valid_attributes}, valid_session
        expect(assigns(:department_shift)).to be_a(DepartmentShift)
        expect(assigns(:department_shift)).to be_persisted
      end

      it "redirects to the created department_shift" do
        post :create, {:department_shift => valid_attributes}, valid_session
        expect(response).to redirect_to(DepartmentShift.last)
      end
    end

    context "with invalid params" do
      it "assigns a newly created but unsaved department_shift as @department_shift" do
        post :create, {:department_shift => invalid_attributes}, valid_session
        expect(assigns(:department_shift)).to be_a_new(DepartmentShift)
      end

      it "re-renders the 'new' template" do
        post :create, {:department_shift => invalid_attributes}, valid_session
        expect(response).to render_template("new")
      end
    end
  end

  describe "PUT #update" do
    context "with valid params" do
      let(:new_attributes) {
        skip("Add a hash of attributes valid for your model")
      }

      it "updates the requested department_shift" do
        department_shift = DepartmentShift.create! valid_attributes
        put :update, {:id => department_shift.to_param, :department_shift => new_attributes}, valid_session
        department_shift.reload
        skip("Add assertions for updated state")
      end

      it "assigns the requested department_shift as @department_shift" do
        department_shift = DepartmentShift.create! valid_attributes
        put :update, {:id => department_shift.to_param, :department_shift => valid_attributes}, valid_session
        expect(assigns(:department_shift)).to eq(department_shift)
      end

      it "redirects to the department_shift" do
        department_shift = DepartmentShift.create! valid_attributes
        put :update, {:id => department_shift.to_param, :department_shift => valid_attributes}, valid_session
        expect(response).to redirect_to(department_shift)
      end
    end

    context "with invalid params" do
      it "assigns the department_shift as @department_shift" do
        department_shift = DepartmentShift.create! valid_attributes
        put :update, {:id => department_shift.to_param, :department_shift => invalid_attributes}, valid_session
        expect(assigns(:department_shift)).to eq(department_shift)
      end

      it "re-renders the 'edit' template" do
        department_shift = DepartmentShift.create! valid_attributes
        put :update, {:id => department_shift.to_param, :department_shift => invalid_attributes}, valid_session
        expect(response).to render_template("edit")
      end
    end
  end

  describe "DELETE #destroy" do
    it "destroys the requested department_shift" do
      department_shift = DepartmentShift.create! valid_attributes
      expect {
        delete :destroy, {:id => department_shift.to_param}, valid_session
      }.to change(DepartmentShift, :count).by(-1)
    end

    it "redirects to the department_shifts list" do
      department_shift = DepartmentShift.create! valid_attributes
      delete :destroy, {:id => department_shift.to_param}, valid_session
      expect(response).to redirect_to(department_shifts_url)
    end
  end

end
